/*
    Copyright (C) 2005-2009  Erik van Pienbroek

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "nntpgrab_utils.h"

#if GLIB_CHECK_VERSION(2,16,0)
GFileMonitor *
nntpgrab_utils_monitor_directory(const char *path, char **errmsg)
{
    GFile *file;
    GFileMonitor *monitor;
    GError *err = NULL;

    file = g_file_new_for_path(path);
    monitor = g_file_monitor_directory(file, G_FILE_MONITOR_NONE, NULL, &err);

    if (!monitor) {
        if (errmsg) {
            *errmsg = g_strdup(err->message);
        }
        g_error_free(err);
        return NULL;
    }

    return monitor;
}

void
nntpgrab_utils_cancel_directory_monitor(GFileMonitor *monitor)
{
    g_file_monitor_cancel(monitor);
}
#endif

