/*
    Copyright (C) 2005-2009  Erik van Pienbroek

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "gui.h"

static void
par2_repair_message_callback(NNTPGrabCore *core, const char *msg, gpointer data)
{
    static gboolean mark_initialized = FALSE;
    GtkTextIter iter;
    GtkWidget *textviewPAR2Repair;
    GtkTextBuffer *buffer;
    GtkTextMark *mark;

    textviewPAR2Repair = nntpgrab_gui_base_get_widget("textviewPAR2Repair");
    buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(textviewPAR2Repair));

    gtk_text_buffer_get_end_iter(buffer, &iter);
    gtk_text_buffer_insert(buffer, &iter, msg, -1);

    gtk_text_buffer_get_end_iter(buffer, &iter);
    gtk_text_buffer_insert(buffer, &iter, "\n", -1);

    // Scroll to the end
    if (!mark_initialized) {
        mark_initialized = TRUE;
        gtk_text_buffer_create_mark (buffer, "scroll", &iter, TRUE);
    }

    mark = gtk_text_buffer_get_mark (buffer, "scroll");
    gtk_text_buffer_get_end_iter (buffer, &iter);

    // Move the iterator to the beginning of line, so we don't scroll in horizontal direction
    gtk_text_iter_set_line_offset (&iter, 0);

    gtk_text_buffer_move_mark (buffer, mark, &iter);
    gtk_text_view_scroll_mark_onscreen(GTK_TEXT_VIEW(textviewPAR2Repair), mark);
}

void
gui_par2_initialize(void)
{
    g_signal_connect(core, "par2_repair_message", G_CALLBACK(par2_repair_message_callback), NULL);

#if 0
    GtkWidget *treeviewPAR2 = get_widget("treeviewPAR2");
    GtkTreeStore *store;
    GtkCellRenderer *cellRenderer;

    cellRenderer = gtk_cell_renderer_text_new();
    gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW(treeviewPAR2), -1, _("PAR2 Set"), cellRenderer, "text", 0, NULL);

    cellRenderer = gtk_cell_renderer_text_new();
    gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW(treeviewPAR2), -1, _("Status"), cellRenderer, "text", 1, NULL);

    cellRenderer = gtk_cell_renderer_text_new();
    gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW(treeviewPAR2), -1, _("Parts missing"), cellRenderer, "text", 2, NULL);

    store = gtk_tree_store_new(3, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_INT);

    gtk_tree_view_set_model(GTK_TREE_VIEW(treeviewPAR2), GTK_TREE_MODEL(store));
#endif
}
