/*
    Copyright (C) 2005-2009  Erik van Pienbroek

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef _PLUGIN_SCHEDULAR_H_
#define _PLUGIN_SCHEDULAR_H_

#include "nntpgrab_plugin_schedular.h"

typedef struct _plugin_schedular_exported_funcs {
    int              (*get_version) (void);

    void             (*destroy) (void);

    gboolean         (*start) (void);
    gboolean         (*stop) (const char *reason);
    gboolean         (*get_state) (void);

    gboolean         (*add_task_to_queue) (const char *collection_name, const NNTPFile *file, char **errmsg);
    gboolean         (*del_task_from_queue) (const char *collection_name, const char *subject, char **errmsg);
    gboolean         (*restart_task) (const char *collection_name, const char *subject, char **errmsg);
    gboolean         (*save_queue) (char **errmsg);
    void             (*foreach_task) (GFunc foreach_func, gpointer data);
    gboolean         (*move_task) (const char *collection_name_src, const char *subject_src, const char *collection_name_dest, int position_dest);
    gboolean         (*move_collection) (const char *collection_name, int new_position);
} PluginSchedularExportedFuncs;

typedef gboolean (*plugin_schedular_init_func) (PluginSchedularImportedFuncs funcs, char **errmsg);

#endif /* _PLUGIN_SCHEDULAR_H_ */
